
--System.usbDiskModeActivate()


System.setHigh()

white = Color.new(255, 255, 255)
black = Color.new(0,0,0)
red = Color.new(255,0,0)
green = Color.new(0,255,0)
blue = Color.new(0,0,255)
grey = Color.new(128,128,128)
brown = Color.new(150,75,0)
buff = Color.new(240,220,130)

mp3 = {}


tempfiles = System.listDirectory()
for i = 3,table.getn(tempfiles) do
	if string.sub(tempfiles[i].name,-4) == ".mp3" or string.sub(tempfiles[i].name,-4) == ".MP3" or string.sub(tempfiles[i].name,-4) == ".Mp3" then
		mp3[table.getn(mp3) + 1] = "../" .. tempfiles[i].name
	end
end


mp3no = 0

System.currentDirectory("System")

dofile("GuBlit.lua")



ship = {
	x = 50,
	y = 136,
	width = 100,
	height = 34,
	vely = 0,
	gravity = 0.17,
	rotation = 0,
	speed = 3,

	name = "Planet Express Ship",

	selection = 1,

	pic = Image.load("data/PXS.png"),
	pic2 = Image.load("data/PXS2.png")
}
shipf = {
	x = ship.x,
	y = ship.y,
	width = 80,
	height = 25,
	}


difficulty = "Original"
menupic = Image.load("data/menu.png")

topobject = {used = 0}
botobject = {used = 0}

for i=0,480 / 40 do
	topobject[i + 1] = {x = (i * 40),y = 0,height = 30,width = 40}
	botobject[i + 1] = {x = (i * 40),y = 242,height = 30,width = 40}
end

--topobject[1] = {x = 480,y = 0,height = 30,width = 40}

--botobject = {used = 0}
--botobject[1] = {x = 480,y = 242,height = 30,width = 40}

ranobject = {used = 0}
ranobject[1] = {x = 540,y = 100,height = 55,width = 35}
ranobject[2] = {x = (540 + (540 / 2)) + 35,y = 130,height = 55,width = 35}

smoketrail = {used = 0,pic = Image.load("data/smoke.png"),pic2 = Image.load("data/fire.png")}
smoketrail[1] = {x = (ship.x + 3),y = (ship.y + 15)}

spacing = 232

bestscore = 0

bestfile = io.open("best_score.dat", "r")
if bestfile then
	bestscore = bestfile:read("*n")
	bestfile:close()
end


function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end


function man_mp3()
	if table.getn(mp3) > 0 then
		if  ((pad:square() ~= oldpad:square()) and pad:square()) then
			Mp3.stop()
			mp3no = 0
		end

		if ((pad:l() ~= oldpad:l()) and pad:l()) or ((pad:r() ~= oldpad:r()) and pad:r()) then
			if ((pad:l() ~= oldpad:l()) and pad:l()) then
				mp3no = mp3no - 1
			elseif ((pad:r() ~= oldpad:r()) and pad:r()) then
				mp3no = mp3no + 1
			end
			if mp3no <= 0 then
				mp3no = table.getn(mp3)
			elseif mp3no > table.getn(mp3) then
				mp3no = 1
			end

			Mp3.stop()
			Mp3.load(mp3[mp3no])
			Mp3.play()
		end

		if Mp3.EndOfStream() == "true" then
			mp3no = mp3no + 1
			if mp3no <= 0 then
				mp3no = table.getn(mp3)
			elseif mp3no > table.getn(mp3) then
				mp3no = 1
			end
			Mp3.stop()
			Mp3.load(mp3[mp3no])
			Mp3.play()
		end
	end

end

function gravity()
	ship.vely = ship.vely + ship.gravity

	if difficulty == "Original" then
		if ship.vely > 3.5 then
			ship.vely = 3.5
		end
	end

	ship.y = ship.y + ship.vely

end

waittimer = Timer.new(0)
waittime = 0

menu = true

function doreset()
	smoketrail = {used = 0,pic = Image.load("data/smoke.png"),pic2 = Image.load("data/fire.png")}
	smoketrail[1] = {x = ship.x + (ship.width / 2),y = (ship.y + 15)}
	crashed = true
	waittimer:start()
end

function reset()
	if waittime < 3000 and crashed and not menu then
		objects()
		gui()
	else
		waittimer:reset(0)
		ship.y = (272 / 2)
		ship.vely = 0
	
--		ship.speed = 3
	
		smoketrail = {used = 0,pic = Image.load("data/smoke.png"),pic2 = Image.load("data/fire.png")}
		smoketrail[1] = {x = (ship.x + 3),y = (ship.y + 15)}
	
		topobject = {used = 0}		
		botobject = {used = 0}
		for i=0,480 / 40 do
			topobject[i + 1] = {x = (i * 40),y = 0,height = 30,width = 40}
			botobject[i + 1] = {x = (i * 40),y = 242,height = 30,width = 40}
		end
		
		ranobject = {used = 0}
		ranobject[1] = {x = 540,y = 100,height = 55,width = 35}
		ranobject[2] = {x = (540 + (540 / 2)) + 35,y = 130,height = 55,width = 35}

	
	
	
		spacing = 232
	
		if round(distance / 20) > best then
			best = round(distance / 20)
		end
		if best > bestscore then
			bestscore = best
			bestfile = io.open("best_score.dat", "w")
			if bestfile then
				bestfile:write(bestscore)
				bestfile:close()
			end
		end
	
--		gametimer:reset(0)
		distance = 0
--		gametimer:start()

		crashed = false

		if menu then -- menu to game
			menu = flase
--			gametimer:start()
		else --game to menu
			menu = true
			distance = 0
		end
	end
end

function rectcollision(object1,object2)
	if (
		(object1.x + object1.width > object2.x) and
		(object1.x < object2.x + object2.width) and
		(object1.y + object1.height > object2.y) and
		(object1.y < object2.y + object2.height)
		) then
		return true

	end
end

changey = 2
refy = math.random(-10,10)

--waittime = math.random(100,300)

crashed = false

function objects()

	if objecttime > 2500 then
		changey = math.random(-20,20)
		objecttimer:reset(0)
		objecttimer:start()
		waittime = math.random(100,300)
	end

--	local refy = refy + (changey * 2)

	while ((refy + changey) + ((272 - spacing) / 2)) <= 5 do
		changey = math.random(1,20)
		objecttimer:reset(0)
		objecttimer:start()
	end
--	elseif 	(272 - (((refy + changey) + ((272 - spacing) / 2)) + spacing)  ) <=5 then
	while 272 - (((refy + changey) + ((272 - spacing) / 2)) + spacing) <= 5 do
		changey = math.random(-20,-1)
		objecttimer:reset(0)
		objecttimer:start()
	end

--		local y = ((refy) + ((272 - spacing) / 2)) + spacing
--		local height = 272 - y


	if topobject[table.getn(topobject)].x < (480 - topobject[table.getn(topobject)].width) then
--		screen:print(10,222,"working",white)
--		local y = refy / 2
		refy = refy + changey
		local height = (refy) + ((272 - spacing) / 2)
--		if height <= 1 then
--			changey = math.random(1,25)
--			objecttimer:reset(0)
--			objecttimer:start()
--		end
		topobject[table.getn(topobject) + 1] = {x = 479,y = 0,height = height,width = 40}

	end

	for i=topobject.used + 1,table.getn(topobject) do
		if (topobject[i].x + topobject[i].width) < 0 then
--			table.remove(topobject,i)
			topobject.used = topobject.used + 1
		end
		if not crashed then
			topobject[i].x = topobject[i].x - ship.speed
		end
		Image:fillRect(topobject[i].x,topobject[i].y,topobject[i].width,topobject[i].height,blue)
--		screen:print(topobject[i].x,topobject[i].y + topobject[i].height,"#",blue)
		if not crashed and not menu then
			if rectcollision(shipf,topobject[i]) then
				doreset()
			end
		end
	end




	if botobject[table.getn(botobject)].x < (480 - botobject[table.getn(botobject)].width) then
--		screen:print(10,222,"working",white)
--		local height = (refy / 2) - ((272 - spacing) / 2)
--		local y = 272 - height

		local y = ((refy) + ((272 - spacing) / 2)) + spacing
		local height = 272 - y
--		if height <= 1 then
--			changey = math.random(-25,-1)
--			objecttimer:reset(0)
--			objecttimer:start()
--		end
		botobject[table.getn(botobject) + 1] = {x = 479,y = y,height = height,width = 40}
	end


	for i=botobject.used + 1,table.getn(botobject) do
		if (botobject[i].x + botobject[i].width) < 0 then
--			table.remove(botobject,i)
			botobject.used = botobject.used + 1
		end
		if not crashed then
			botobject[i].x = botobject[i].x - ship.speed
		end
		Image:fillRect(botobject[i].x,botobject[i].y,botobject[i].width,botobject[i].height,blue)
--		screen:print(botobject[i].x,botobject[i].y + botobject[i].height,"#",blue)
		if not crashed and not menu then
			if rectcollision(shipf,botobject[i]) then
				doreset()
			end
		end
	end



	for i = 1,2 do
		if (ranobject[i].x + ranobject[i].width) < 0 then
			ranobject[i] = {x = 540,y = math.random((refy) + ((272 - spacing) / 2),(((refy) + ((272 - spacing) / 2)) + spacing) - 55),height = 55,width = 35}
		end
		if not crashed then
			ranobject[i].x = ranobject[i].x - ship.speed
		end
		Image:fillRect(ranobject[i].x,ranobject[i].y,ranobject[i].width,ranobject[i].height,green)
		if not crashed and not menu then
			if rectcollision(shipf,ranobject[i]) then
				doreset()
			end
		end
	end


	if not crashed and not menu then
		if smoketrail[table.getn(smoketrail)].x < 20 then
			smoketrail[table.getn(smoketrail) + 1] = {x = ship.x + 3,y = (ship.y + 15)}
		end
		for i=smoketrail.used + 1,table.getn(smoketrail) do
			if (smoketrail[i].x + 20) < 0 then
				smoketrail.used = smoketrail.used + 1
			end
			smoketrail[i].x = smoketrail[i].x - ship.speed
			screen:blit(smoketrail[i].x,smoketrail[i].y,smoketrail.pic)
		end
	elseif crashed then
		if smoketrail[table.getn(smoketrail)].y < (ship.y + (ship.height / 2)) - 40 then
			smoketrail[table.getn(smoketrail) + 1] = {x = ship.x + (ship.width / 2),y = (ship.y + 15)}
		end
		for i=smoketrail.used + 1,table.getn(smoketrail) do
			if (smoketrail[i].y + 20) < (ship.y + (ship.height / 2)) - 100 then
				smoketrail.used = smoketrail.used + 1
			end
			smoketrail[i].y = smoketrail[i].y - 1
			screen:blit(smoketrail[i].x,smoketrail[i].y,smoketrail.pic2)
		end
	end
end

pressed = false
best = 0

function gui()
	screen:print(20,252,"Distance: " .. round(distance / 20),white)
	screen:print(390,252,"Best: " .. best,white)
	screen:print(390 - (5 * 7.5),10,"Best Ever: " .. bestscore,white)
	if mp3no > 0 then
		screen:print(30,10,"Now Playing: ".. string.sub(mp3[mp3no],4,-5),white)
	end

end

upforce = 0.25


function controlls()
	if pad:cross() or pad:circle() or pad:up() then
		pressed = true
		ship.vely = ship.vely - upforce
		if difficulty == "Original" then
			if ship.vely < -3 then
				ship.vely = -3
			end
		end
	end
		
	man_mp3()
--	if pad:select() then
--	end
end

math.randomseed( os.time() )
objecttimer = Timer.new(0)
objecttime = 0

objecttimer:start()


--gametimer = Timer.new(0)
--gametime = 0

--gametimer:start()


oldpad = Controls.read()

distance = 0

diffsel = 3

while true do
	if not menu then
		start_gu()
		if difficulty == "Original" then
			GuBlit((ship.x + (ship.width / 2)) - 240,-((ship.y + (ship.height / 2)) - 136),-290,ship.pic2,0,0,-(ship.vely * 2.5))
		else
			GuBlit((ship.x + (ship.width / 2)) - 240,-((ship.y + (ship.height / 2)) - 136),-290,ship.pic2,0,0,-(ship.vely * 4))
		end
		Gu.end3d()
	
	
	--	screen:clear(black)
	--	math.randomseed( os.time() )
		pad = Controls.read()
	
		if not crashed then
--			gametime = gametimer:time()
			distance = distance + ship.speed
			objecttime = objecttimer:time()
		end
		waittime = waittimer:time()
	
		shipf.x = ship.x + ((ship.width - shipf.width) / 2)
		shipf.y = ship.y + ((ship.height - shipf.height) / 2)
	
		if not crashed then
			gravity()
			controlls()
		
			objects()
		end
	
		gui()

--		screen:print(10,10,spacing,white)
	
	
		if not crashed then
			if (ship.y + ship.height) > 272 or ship.y < 0 then
				doreset()
			end
		
			ship.speed = ship.speed + 0.0002

			if spacing > 195 then
				spacing = spacing - (0.01 * (ship.speed - 2))
			elseif spacing > 185 then
				spacing = spacing - (0.01 * (ship.speed - 3))	
			end
		end
	
--		if pad:start() then
--			break
--		end
	
--		if pad:select() then screen:save("screenshot.tga") end
	
		pressed = false
	
		if crashed then
			reset()
		end

	--	crashed = false
		oldpad = pad


	
		screen.waitVblankStart()
		screen.flip()
	else
		screen:clear(black)
	
		pad = Controls.read()
	
		objects()
	
		screen:blit(0,0,menupic)
	
		screen:blit(101 - (ship.width / 2),186 - (ship.height / 2),ship.pic)
	
		screen:print(363 - ((string.len(difficulty) * 7.5) / 2),186,difficulty,white)
		screen:print(100 - ((string.len(ship.name) * 7.5) / 2),213,ship.name,white)
	
		gui()

		man_mp3()

		objecttime = objecttimer:time()
	
		if ((pad:up() ~= oldpad:up()) and pad:up()) or ((pad:down() ~= oldpad:down()) and pad:down()) then
			if ((pad:up() ~= oldpad:up()) and pad:up()) then
				diffsel = diffsel + 1
			elseif ((pad:down() ~= oldpad:down()) and pad:down()) then
				diffsel = diffsel - 1
			end

			if diffsel > 3 then
				diffsel = 1
			elseif diffsel < 1 then
				diffsel = 3
			end

			if diffsel == 1 then
				difficulty = "Easy"
			elseif diffsel == 2 then
				difficulty = "Hard"
			elseif diffsel == 3 then
				difficulty = "Original"
			end
		end


		if ((pad:right() ~= oldpad:right()) and pad:right()) or ((pad:left() ~= oldpad:left()) and pad:left()) then
			if ((pad:right() ~= oldpad:right()) and pad:right()) then
				ship.selection = ship.selection + 1
			elseif ((pad:left() ~= oldpad:left()) and pad:left()) then
				ship.selection = ship.selection - 1
			end
	
			if ship.selection > 4 then
				ship.selection = 1
			elseif ship.selection < 1 then
				ship.selection = 4
			end
	
			if ship.selection == 1 then
				ship.width = 100
				ship.height = 34
	
				ship.pic = Image.load("data/PXS.png")
				ship.pic2 = Image.load("data/PXS2.png")
	
				ship.speed = 3.5
	
				shipf.width = 80
				shipf.height = 25
	
				ship.name = "Planet Express Ship"
	
			elseif ship.selection == 2 then
				ship.width = 100
				ship.height = 31
	
				ship.pic = Image.load("data/f22.png")
				ship.pic2 = Image.load("data/f222.png")
	
				ship.speed = 5
	
				shipf.width = 80
				shipf.height = 17
				ship.name = "F-22 Raptor"
	
			elseif ship.selection == 3 then
				ship.width = 60
				ship.height = 31
	
				ship.pic = Image.load("data/superman.png")
				ship.pic2 = Image.load("data/superman2.png")
	
				ship.speed = 5.5
	
				shipf.width = 55
				shipf.height = 26
				ship.name = "Super Man"
			elseif ship.selection == 4 then
				ship.width = 75
				ship.height = 34
	
				ship.pic = Image.load("data/helicoper.png")
				ship.pic2 = Image.load("data/helicoper2.png")
	
				ship.speed = 3.5
	
				shipf.width = 70
				shipf.height = 29
				ship.name = "Helicopter"
			end
		end

		if ((pad:cross() ~= oldpad:cross()) and pad:cross()) then
			if difficulty == "Hard" then
				ship.gravity = 0.17
				upforce = 0.25
			elseif difficulty == "Original" then
				ship.gravity = 0.25
				upforce = 0.43
			elseif difficulty == "Easy" then
				ship.gravity = 0.1
				upforce = 0.2
			end

			if ship.selection == 1 then
				ship.speed = 3.5
			elseif ship.selection == 2 then
				ship.speed = 5
			elseif ship.selection == 3 then
				ship.speed = 5.5
			elseif ship.selection == 3 then
				ship.speed = 3.5
			end
	--		menu = false

			reset()
		end

--		if pad:select() then screen:save("screenshot.tga") end
	
--		if pad:start() then
--			break
--		end
	
		oldpad = pad
	
		screen.waitVblankStart()
		screen.flip()
	end


end